import { d, y, A as AnnotationSource, h, p, c as cls, a as AnnotationSourcesList, P } from "../AnnotationSourcesList.js";
const select$1 = "_select_1aut8_2";
const button$1 = "_button_1aut8_3";
const loading$1 = "_loading_1aut8_18";
const success$1 = "_success_1aut8_25";
var classes$1 = {
  select: select$1,
  button: button$1,
  loading: loading$1,
  success: success$1
};
class AnnotationStoreSelector extends d {
  constructor() {
    super(...arguments);
    this.state = {};
    this.selectElement = y();
    this.testButton = y();
  }
  async componentDidMount() {
    await this.loadData();
  }
  async loadData() {
    const possiblyWritableSources = await AnnotationSource.getPossiblyWritableSources();
    const selectedSource = possiblyWritableSources.find((source) => source.data.useForNewAnnotations);
    this.setState({
      possiblyWritableSources,
      selectedSource
    });
  }
  async onChange() {
    var _a;
    const optionValue = (_a = this.selectElement.current) == null ? void 0 : _a.value;
    const selectedSourceId = optionValue ? +optionValue : null;
    const selectedSource = selectedSourceId ? await AnnotationSource.get(selectedSourceId) : null;
    this.setState({ selectedSource, testSuccess: false });
  }
  async testCreateAnnotation() {
    var _a, _b;
    (_a = this.testButton.current) == null ? void 0 : _a.classList.add(classes$1.loading);
    const { selectedSource } = this.state;
    try {
      if (!selectedSource)
        throw new Error("No source selected to test.");
      await selectedSource.testWritable();
      this.setState({ testSuccess: true });
      const allSources = await AnnotationSource.getAll();
      await Promise.all(allSources.map((source) => source.useForNewAnnotations(source.data._id === selectedSource.data._id)));
      await this.loadData();
    } catch (error) {
      this.setState({ testSuccess: false });
      alert(error);
    } finally {
      (_b = this.testButton.current) == null ? void 0 : _b.classList.remove(classes$1.loading);
    }
  }
  render({}, {
    possiblyWritableSources,
    selectedSource,
    testSuccess
  }) {
    var _a;
    const optionsList = possiblyWritableSources == null ? void 0 : possiblyWritableSources.sort((a, b) => a.data.writable === b.data.writable ? 0 : b.data.writable ? 1 : -1).map((source) => /* @__PURE__ */ h("option", {
      value: source.data._id,
      selected: source.data._id === (selectedSource == null ? void 0 : selectedSource.data._id)
    }, source.data.writable ? "\u2713" : "\uFF1F", " ", source.data.title, " <", source.data.url, ">"));
    if ((optionsList == null ? void 0 : optionsList.length) === 0) {
      return /* @__PURE__ */ h("p", null, "To create annotations, first subscribe to a collection (that you have write access to).");
    }
    return /* @__PURE__ */ h(p, null, /* @__PURE__ */ h("p", null, "Choose the collection to store/publish annotations you create:"), /* @__PURE__ */ h("select", {
      ref: this.selectElement,
      value: `${(_a = selectedSource == null ? void 0 : selectedSource.data._id) != null ? _a : ""}`,
      onChange: (e) => this.onChange(),
      class: classes$1.select
    }, /* @__PURE__ */ h("option", {
      value: ""
    }, "None"), optionsList), selectedSource && /* @__PURE__ */ h(p, null, /* @__PURE__ */ h("button", {
      onClick: () => this.testCreateAnnotation(),
      title: "Click to test if you can create an annotation in the chosen collection. Your browser may prompt you to provide login credentials.",
      ref: this.testButton,
      class: cls(classes$1.button, { [classes$1.success]: testSuccess })
    }, testSuccess ? "Connected" : selectedSource.data.writable ? selectedSource.data.needsAuth ? "Reconnect" : "Check" : "Connect"), selectedSource.data.writable && selectedSource.data.needsAuth && /* @__PURE__ */ h("p", null, "Your browser appears to have lost write access to the collection. Please click reconnect to try log in again.")));
  }
}
const select = "_select_4kz4m_15";
const button = "_button_4kz4m_16";
const loading = "_loading_4kz4m_31";
const success = "_success_4kz4m_38";
var classes = {
  select,
  button,
  loading,
  success
};
class Popup extends d {
  constructor() {
    super(...arguments);
    this.state = {};
  }
  render({}, {}) {
    return /* @__PURE__ */ h(p, null, /* @__PURE__ */ h("h1", null, "Web Annotator"), /* @__PURE__ */ h("h2", null, "Creating annotations"), /* @__PURE__ */ h(AnnotationStoreSelector, null), /* @__PURE__ */ h("h2", null, "Your annotation library:"), /* @__PURE__ */ h(AnnotationSourcesList, {
      withAnnotations: false
    }), /* @__PURE__ */ h("br", null), /* @__PURE__ */ h("a", {
      class: classes.button,
      href: browser.runtime.getURL("overview/index.html"),
      target: "_blank"
    }, "Show all stored annotations."));
  }
}
main();
async function main() {
  const container = document.getElementById("app");
  P(/* @__PURE__ */ h(Popup, null), container);
}
//# sourceMappingURL=index.js.map
